



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python基础：列表生成式和生成器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python基础：列表生成式和生成器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 10:28:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>列表生成式(List Comprehension)</h2>
<hr />
<p>列表生成式即List Comprehensions，是Python内置的非常简单却强大的可以用来创建list的生成式。</p>
<p>举个例子，要生成&nbsp;list [, , , , , , , , , ]&nbsp;可以用&nbsp;range(, )&nbsp;：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; range(1, 11)<br />
[1, 2, 3, 4, 5, 6, 7, 8, 9, 10]
</pre>
</div>
<p>但如果要生成<code>[1x1, 2x2, 3x3, ..., 10x10]</code>怎么做？方法一是循环：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; L = []<br />
&gt;&gt;&gt; for x in range(1, 11):<br />
...    L.append(x * x)<br />
...<br />
&gt;&gt;&gt; L<br />
[1, 4, 9, 16, 25, 36, 49, 64, 81, 100]
</pre>
</div>
<p>但是循环太繁琐，而<strong>列表生成式</strong>则可以用一行语句代替循环生成上面的list：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; [x * x for x in range(1, 11)]<br />
[1, 4, 9, 16, 25, 36, 49, 64, 81, 100]
</pre>
</div>
<p>写列表生成式时，把要生成的元素<code>x * x</code>放到前面，后面跟<code>for</code>循环，就可以把list创建出来，十分有用，多写几次，很快就可以熟悉这种语法。</p>
<p>for循环后面还可以加上if判断，这样我们就可以筛选出仅偶数的平方：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; [x * x for x in range(1, 11) if x % 2 == 0]<br />
[4, 16, 36, 64, 100]
</pre>
</div>
<p>还可以使用两层循环，可以生成全排列：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; [m + n for m in 'ABC' for n in 'XYZ']<br />
['AX', 'AY', 'AZ', 'BX', 'BY', 'BZ', 'CX', 'CY', 'CZ']
</pre>
</div>
<p><code>for</code>循环其实可以同时使用两个甚至多个变量，比如<code>dict</code>的<code>iteritems()</code>可以同时迭代key和value：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; d = {'x': 'A', 'y': 'B', 'z': 'C' }<br />
&gt;&gt;&gt; for k, v in d.iteritems():<br />
...     print k, '=', v<br />
...<br />
y = B<br />
x = A<br />
z = C</pre>
</div>
<p>因此，列表生成式也可以使用两个变量来生成list：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; d = {'x': 'A', 'y': 'B', 'z': 'C' }<br />
&gt;&gt;&gt; [k + '=' + v for k, v in d.iteritems()]<br />
['y=B', 'x=A', 'z=C']</pre>
</div>
<p>最后把一个list中所有的字符串变成小写：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; L = ['Hello', 'World', 'IBM', 'Apple']<br />
&gt;&gt;&gt; [s.lower() for s in L]<br />
['hello', 'world', 'ibm', 'apple']
</pre>
</div>
<h2>列表生成式总结：</h2>
<hr />
<div>
<pre class="prettyprint linenums"># List comprehension<br />
[expression for var in iterable]
</pre>
</div>
<p>列表推导式书写形式：　　</p>
<p><strong>[表达式&nbsp;for&nbsp;变量&nbsp;in&nbsp;列表] &nbsp; &nbsp;或者 &nbsp;[表达式&nbsp;for&nbsp;变量&nbsp;in&nbsp;列表&nbsp;if&nbsp;条件]</strong></p>
<p>简单的理解列表推倒式：</p>
<div>
<pre class="prettyprint linenums">def _lc(arg):<br />
    result = []<br />
    for i in arg:<br />
        result.append(i * i)<br />
    return result

&lt;expr_value&gt; = _lc(x)<br />
'''<br />
列表推导式会把所有数据都加载到内存。适合 &ldquo;结果需要多次被使用&rdquo; 或者 &ldquo;需要使用list相关的方法（分片等）&rdquo; 等的情况。

'''
</pre>
</div>
<p>应用实例：</p>
<div>
<pre class="prettyprint linenums"># arg is a list<br />
# the return of _lc is a list<br />
def _lc(arg):<br />
	result = []<br />
	for i in arg:<br />
		result.append(i * i)<br />
	return result

table = [1,2,3,4,5]<br />
res = _lc(table)<br />
print res
</pre>
</div>
<p>代码执行结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/398159/201601/398159-20160104145725200-1919610646.png" /></p>
<h2>生成器(Generator Expression)</h2>
<hr />
<p>通过列表生成式，我们可以直接创建一个列表。但是，受到内存限制，列表容量肯定是有限的。而且，创建一个包含100万个元素的列表，不仅占用很大的存储空间，如果我们仅仅需要访问前面几个元素，那后面绝大多数元素占用的空间都白白浪费了。</p>
<p>所以，如果列表元素可以按照某种算法推算出来，那我们是否可以在循环的过程中不断推算出后续的元素呢？<strong>这样就不必创建完整的list，从而节省大量的空间。在Python中，这种一边循环一边计算的机制，称为生成器（Generator）</strong>。</p>
<p>要创建一个generator，有很多种方法。</p>
<p>第一种方法很简单，只要把一个列表生成式的<code>[]</code>改成<code>()</code>，就创建了一个generator：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; L = [x * x for x in range(10)]<br />
&gt;&gt;&gt; L<br />
[0, 1, 4, 9, 16, 25, 36, 49, 64, 81]<br />
&gt;&gt;&gt; g = (x * x for x in range(10))<br />
&gt;&gt;&gt; g<br />
&lt;generator object &lt;genexpr&gt; at 0x104feab40&gt;
</pre>
</div>
<p>创建<code>L</code>和<code>g</code>的区别仅在于最外层的<code>[]</code>和<code>()</code>，<code>L</code>是一个list，而<code>g</code>是一个generator。</p>
<p>我们可以直接打印出list的每一个元素，但我们怎么打印出generator的每一个元素呢？</p>
<p>如果要一个一个打印出来，可以通过generator的<code>next()</code>方法：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; g.next()<br />
0<br />
&gt;&gt;&gt; g.next()<br />
1<br />
&gt;&gt;&gt; g.next()<br />
4<br />
&gt;&gt;&gt; g.next()<br />
9<br />
&gt;&gt;&gt; g.next()<br />
16<br />
&gt;&gt;&gt; g.next()<br />
25<br />
&gt;&gt;&gt; g.next()<br />
36<br />
&gt;&gt;&gt; g.next()<br />
49<br />
&gt;&gt;&gt; g.next()<br />
64<br />
&gt;&gt;&gt; g.next()<br />
81<br />
&gt;&gt;&gt; g.next()<br />
Traceback (most recent call last):<br />
  File "&lt;stdin&gt;", line 1, in &lt;module&gt;<br />
StopIteration
</pre>
</div>
<p>我们讲过，generator保存的是算法，每次调用<code>next()</code>，就计算出下一个元素的值，直到计算到最后一个元素，没有更多的元素时，抛出StopIteration的错误。</p>
<p>当然，上面这种不断调用<code>next()</code>方法实在是太变态了，正确的方法是使用<code>for</code>循环，因为generator也是可迭代对象：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; g = (x * x for x in range(10))<br />
&gt;&gt;&gt; for n in g:<br />
...     print n<br />
...<br />
0<br />
1<br />
4<br />
9<br />
16<br />
25<br />
36<br />
49<br />
64<br />
81
</pre>
</div>
<p>所以，我们创建了一个generator后，基本上永远不会调用<code>next()</code>方法，而是通过<code>for</code>循环来迭代它。</p>
<p>generator非常强大。如果推算的算法比较复杂，用类似列表生成式的<code>for</code>循环无法实现的时候，还可以用函数来实现。</p>
<p>比如，著名的斐波拉契数列（Fibonacci），除第一个和第二个数外，任意一个数都可由前两个数相加得到：</p>
<div>
<pre class="prettyprint linenums">1, 1, 2, 3, 5, 8, 13, 21, 34, ...</pre>
</div>
<p>斐波拉契数列用<strong>列表生成式</strong>写不出来，但是，用函数把它打印出来却很容易：</p>
<div>
<pre class="prettyprint linenums">def fib(max):<br />
    n, a, b = 0, 0, 1<br />
    while n &lt; max:<br />
        print b<br />
        a, b = b, a + b<br />
        n = n + 1
</pre>
</div>
<p>上面的函数可以输出斐波那契数列的前N个数：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; fib(6)<br />
1<br />
1<br />
2<br />
3<br />
5<br />
8
</pre>
</div>
<p>仔细观察，可以看出，<code>fib</code>函数实际上是定义了斐波拉契数列的推算规则，可以从第一个元素开始，推算出后续任意的元素，这种逻辑其实非常类似generator。</p>
<p>也就是说，上面的函数和generator仅一步之遥。要把<code>fib</code>函数变成generator，只需要把<code>print b</code>改为<code>yield b</code>就可以了：</p>
<div>
<pre class="prettyprint linenums">def fib(max):<br />
    n, a, b = 0, 0, 1<br />
    while n &lt; max:<br />
        yield b<br />
        a, b = b, a + b<br />
        n = n + 1
</pre>
</div>
<p>这就是定义generator的另一种方法。如果一个函数定义中包含<code>yield</code>关键字，那么这个函数就不再是一个普通函数，而是一个generator：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; fib(6)<br />
&lt;generator object fib at 0x104feaaa0&gt;
</pre>
</div>
<p>这里，最难理解的就是generator和函数的执行流程不一样。函数是顺序执行，遇到return语句或者最后一行函数语句就返回。而变成generator的函数，在每次调用<code>next()</code>的时候执行，遇到<code>yield</code>语句返回，再次执行时从上次返回的<code>yield</code>语句处继续执行。</p>
<p>举个简单的例子，定义一个generator，依次返回数字1，3，5：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; def odd():<br />
...     print 'step 1'<br />
...     yield 1<br />
...     print 'step 2'<br />
...     yield 3<br />
...     print 'step 3'<br />
...     yield 5<br />
...<br />
&gt;&gt;&gt; o = odd()<br />
&gt;&gt;&gt; o.next()<br />
step 1<br />
1<br />
&gt;&gt;&gt; o.next()<br />
step 2<br />
3<br />
&gt;&gt;&gt; o.next()<br />
step 3<br />
5<br />
&gt;&gt;&gt; o.next()<br />
Traceback (most recent call last):<br />
  File "&lt;stdin&gt;", line 1, in &lt;module&gt;<br />
StopIteration
</pre>
</div>
<p>可以看到，<code>odd</code>不是普通函数，而是generator，在执行过程中，遇到<code>yield</code>就中断，下次又继续执行。执行3次<code>yield</code>后，已经没有<code>yield</code>可以执行了，所以，第4次调用<code>next()</code>就报错。</p>
<p>回到<code>fib</code>的例子，我们在循环过程中不断调用<code>yield</code>，就会不断中断。当然要给循环设置一个条件来退出循环，不然就会产生一个无限数列出来。</p>
<p>同样的，把函数改成generator后，我们基本上从来不会用<code>next()</code>来调用它，而是直接使用<code>for</code>循环来迭代：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; for n in fib(6):<br />
...     print n<br />
...<br />
1<br />
1<br />
2<br />
3<br />
5<br />
8
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/q7mnxpjq.html">能在你离开时照顾你的宠物的3D打印机器人</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xg5mr9.html">js获取上传文件内容&lpar;未完待续&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v1nyn8.html">Java实战之02Hibernate-06处理并发</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0gw1gq.html">ccmenu里的位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmd72x9.html">hibernate使用sql语句查询实体时，要写上addEntity</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpepj7q.html">EDStarRating&lpar;IOS星级评定&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9500lg08.html">初步swift语言学习笔记6&lpar;ARC-自己主动引用计数&comma;内存管理&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pllj48.html">【集美大学1411&lowbar;助教博客】团队作业5&mdash;&mdash;测试与发布（Alpha版本）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjl7r28.html">&lbrack;转&rsqb;如何用adb控制MTKLogger</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjk2lk8.html">C&plus;&plus;学习笔记第一天：基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjpykk8.html">Excel as a Service &amp;mdash&semi;&amp;mdash&semi; Excel 开发居然可以这么玩</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyk1dz9.html">【USACO 5&period;3&period;1】量取牛奶 迭代</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gxkymq.html">创建postgresql表空间</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1gz4xq.html">简化实现动态行列转置的SQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy0zmxq.html">Spring boot  参数相关注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjlgr59.html">使用linux计划任务自动拉起停止的通达OA服务apache和mysql服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/953x1lz8.html">Vue学习系列---安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm125e9.html">ACM经验分享&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/953mdye8.html">zookeeper与卡夫卡集群搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppxwgd9.html">&dollar;digest already in progress 解决办法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96ox25j9.html">在EasyUI中统一判断是否有选中行，如果有则将选中行数据传入回调函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv6proq.html">Winform单例模式与传值</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yr5eeq.html">Failed to create the Java Virtual Machine  （Myeclipse或者eclipse启动报错）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn17xnj8.html">android ellipsize 属性详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnpvpz8.html">&lbrack;汇编语言&rsqb;-第五章&lbrack;bx&rsqb;和loop指令</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yrl4jq.html">命名空间 - PHP手册笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1yxm59.html">运算符 - PHP手册笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd16ll8.html">Oracle EBS-SQL &lpar;PO-18&rpar;&colon;检查工作台下达的PR在系统找不到&period;sql</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ox13n9.html">Oracle EBS-SQL &lpar;INV-9&rpar;&colon;检查搬运单分配异常&period;sql</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0wy3lq.html">JavaEE Tutorials &lpar;25&rpar; - 使用Java EE拦截器</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
